/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/util/RCS/natinfo.c,v 5.5 1996/04/02 07:11:09 jpo Exp $
    $Date: 1996/04/02 07:11:09 $
    $Author: jpo $
    $Id: natinfo.c,v 5.5 1996/04/02 07:11:09 jpo Exp $
    $Locker:  $
    $Log: natinfo.c,v $
    Revision 5.5  1996/04/02 07:11:09  jpo
    Fixup some lint stuff

    Revision 5.4  1996/01/29 08:37:19  jpo
    Remove termcap specific stuff

    Revision 5.3  1995/09/12 19:00:45  jpo
    Make space a little neater

    Revision 5.2  1995/09/12 18:51:44  jpo
    Change to use strings

    Revision 5.1  1993/03/14 16:52:57  etienne
    *** empty log message ***

 * Revision 5.0  93/02/06  09:24:11  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:45:54  greyhelm
 * Added RCS headers - Karl Hagen
 *

*/
#include <main.h>

void UtilNatInfo (x, y)
int x, y;
{
	char * ptr;
	RepInfo repinfo;
	RelInfo relinfo;
	int c;
	Strings strings;

	ptr = AskCountry (x, y, "About which country?", False);
	if (ptr == (char *) 0)
		return;

	c = CountryId (ptr);

	if (c < 0)
	{
		Panic ("UtilNatInfo", __FILE__,
		       "Couldn't find country");
		return;
	}

	if (c == 0)
	{
		Message ("No country info on the deity");
		Bell ();
		return;
	}

	relinfo = ScanRelationsAs (c);
	repinfo = ScanReportAs (c);
	ScanPower ();

	strings = InitStrings ();
	PrintPowerString (strings, c);

	AddString (strings, "");
	PrintRepInfo (strings, repinfo);
	AddString (strings, "");
	PrintRelations (strings, relinfo);

	FreeReportInfo (repinfo);
	FreeRelInfo (relinfo);

	ShowStringsInPager (strings, Fmt("Info about %s", ptr));
}
