/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/xm/RCS/xmisc.c,v 5.2 1996/04/23 07:51:39 jpo Exp $
    $Date: 1996/04/23 07:51:39 $
    $Author: jpo $
    $Id: xmisc.c,v 5.2 1996/04/23 07:51:39 jpo Exp $
    $Locker:  $
    $Log: xmisc.c,v $
    Revision 5.2  1996/04/23 07:51:39  jpo
    Chaneg to use toolkit

    Revision 5.1  1993/03/14 16:35:53  etienne
    *** empty log message ***

 * Revision 5.0  93/02/06  09:26:31  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:00:52  greyhelm
 * Add RCS logging - Karl Hagen
 *

*/
#include <X11/Intrinsic.h>

#include "type.h"
#include "xextern.h"
#include "main.h"
#include "sector.h"
#include "nation.h"

extern XtAppContext app_context;

bool SelButtonAtWin (win, x, y, button)
WinInfo win;
int * x, * y, * button;
{
 	XEvent event;
 
 	for (;;)
 	{
 		XtAppNextEvent (app_context, &event);
 		switch (event. type)
 		{
 
 		case ButtonPress:

 			if (EventWindow (& event) != win)
 				return False;
 
 			if (button != (int *) 0)
 				*button = event. xbutton. button;
 			
 			if (x != (int *) 0)
 				* x = PixelToCharX (event. xbutton. x);
 			
 			if (y != (int *) 0)
 				* y = PixelToCharY (event. xbutton. y);
 
 			return True;
		}
		XtDispatchEvent (&event);
	}
}

Sector SelectSector (button)
int * button;
{
	Sector sct;
	int x, y;

	sct = (Sector) 0;
	do {
		if (SelectSctCrd (& x, & y, button))
			sct = World (x, y, S_EXIST);
	}
	while (sct == (Sector) 0);

	return sct;
}

bool SelectSctCrd (x, y, button)
int *x, *y;
int *button;
{
	if (GetXSector (x, y, button) == False)
		return False;
	if (! ConvertToSctCrd (x, y))
		return False;
	return True;
}

void WaitButtonPress (button)
int *button;
{
	XEvent event;

	if (! xstarted)
		return;

	for (;;)
	{
		XtAppNextEvent (app_context, &event);
		switch (event. type)
		{
		case ButtonPress:
			if (button != (int *) 0)
				*button = event. xbutton. button;
			return;
		}
		XtDispatchEvent (&event);
	}
}

void Pause ()
{
	XEvent event;

	if (! xstarted)
		return;

	for (;;)
	{
		XtAppNextEvent (app_context, &event);
		if (event. type == ButtonPress ||
		    event. type == KeyPress)
			return;
		XtDispatchEvent (&event);
	}
}

bool interrupt = False;

bool SetInterrupt (pevent)
XEvent *pevent;
{
	KeySym keysym;
	XComposeStatus comp_status;
	char buffer [BUFSIZ];
	extern char intrchar;

	if (pevent-> type == KeyPress)
	{
		if (XLookupString (& (pevent-> xkey), buffer, BUFSIZ - 1,
					&keysym, &comp_status) == 0)
			return False;
		if (buffer[0] == intrchar)
		{
			interrupt = True;
			return True;
		}
	}
	return False;
}
